![Version](https://img.shields.io/badge/Version-1.0.15-orange)
![Build](https://github.com/cheeeeeeeeeen/RoR2-ChensHelpers/workflows/Build/badge.svg)
[![License: GPL v3](https://img.shields.io/badge/License-GPLv3-blue.svg)](https://www.gnu.org/licenses/gpl-3.0)
[![Support Chen](https://img.shields.io/badge/Support-Chen-ff69b4)](https://ko-fi.com/cheeeeeeeeeen)

[![GitHub issues](https://img.shields.io/github/issues/cheeeeeeeeeen/RoR2-ChensHelpers)](https://github.com/cheeeeeeeeeen/RoR2-ChensHelpers/issues)
[![GitHub pull requests](https://img.shields.io/github/issues-pr/cheeeeeeeeeen/RoR2-ChensHelpers)](https://github.com/cheeeeeeeeeen/RoR2-ChensHelpers/pulls)
![Maintenance Status](https://img.shields.io/badge/Maintainance-Active-brightgreen)

# Chen's Helpers

## Description

A Risk of Rain 2 mod library of helpers that may aid other mod creators.

It contains easy helpers for debugging and improve quality of life coding for modding Risk of Rain 2.

The library is **fully documented**.

## How to use

Use **[Thunderstore Mod Manager](https://www.overwolf.com/app/Thunderstore-Thunderstore_Mod_Manager)** to install this mod.

If one does not want to use a mod manager, then get the DLL from **[Thunderstore](https://thunderstore.io/package/Chen/ChensHelpers/)**.

## Notable Features
- Minion Ownership assignment with synchronization support and queuing system. The helper does it all instead of manually syncing them.
- Different wave functions available, especially the sine wave.
- Assets Manager which registers your custom Unity Asset and WWise sound bundles included in your mod.
- General modding helpers for testing in-game, such as Pickup Droplet Generators and testing of WWise sounds.
- Fetching + Adding Components to Game Objects. Easily fetch or add the component in a single line of code.
- Easily implement List Processors and Queue Processors.
- Easily replace generic models of certain game objects with custom ones.
- Extensions to C# Enumerable and native Objects, such as easily converting an array to a List.
- Quick access to the host player object of the game when catering to multiplayer features.
- Extension to BepInEx loggers, such as allowing to print an array easily by calling just one method.
- Easy to implement Generic Content Pack Provider for adding new CharacterBody and CharacteMaster prefabs.
- Easily create a deep copy of any component.
- Quickly replace shaders to map with Risk of Rain 2's shaders.
- Modified Blast Attack inherited from vanilla so that it returns victims instead of just the number.
- Various components implemented, such as a Temporary Particle System that automatically destroys itself.
- Attach a Material Controller component easily to edit materials live.
- ... and many more. Check the [documentation](https://cheeeeeeeeeen.github.io/RoR2-ChensHelpers/).

## Contact
- Issue Page: https://github.com/cheeeeeeeeeen/RoR2-ChensHelpers/issues
- Email: `blancfaye7@gmail.com`
- Discord: `Chen#1218`
- RoR2 Modding Server: https://discord.com/invite/5MbXZvd
- Give a tip through Ko-fi: https://ko-fi.com/cheeeeeeeeeen